<script setup lang="ts">
import { computed, nextTick, onMounted, ref, watch } from 'vue'
import http from '@/services/http'
import { type Product } from '@/types/Product'

import MemberCard from './MemberCard.vue'
import ProductList from '@/components/ProductList.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import Payment from './Payment.vue'
import QrcodeDialog from './Qrcode.vue'
import Promptpay from './Promptpay.vue'

import { useReceiptStore } from '@/stores/receipt'
import { usePaymentStore } from '@/stores/payment'
import { useProductStore } from '@/stores/product'
import { useLoadingStore } from '@/stores/loading'

import { provide } from 'vue'

const productStore = useProductStore()
const paymentStore = usePaymentStore()
const cashdialog = ref(false)
const loadingStore = useLoadingStore()
provide('paymentDialog', cashdialog)

const qrcodedialog = ref(false)
provide('QrcodeDialog', qrcodedialog)

const promptpaydialog = ref(false)
provide('PromptpayDialog', promptpaydialog)

const receiptStore = useReceiptStore()

const drinks = computed(() => {
  return productStore.products.filter((product) => product.type.id === 1)
})

const desserts = computed(() => {
  return productStore.products.filter((product) => product.type.id === 2)
})

const foods = computed(() => {
  return productStore.products.filter((product) => product.type.id === 3)
})
const tab = ref(1)
const selected = (p: Product) => {
  console.log('ProductView: ' + p)
  receiptStore.addReceiptItem(p)
  nextTick(() => {
    if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
  })
}

const clearReceipt = function () {
  receiptStore.clear()
}
const divReceiptItems = ref<HTMLElement | null>(null)
const searchQuery = ref('')
const filteredProducts = ref<Product[]>([])

const updateFilteredProducts = () => {
  switch (tab.value) {
    case 1:
      filteredProducts.value = drinks.value
      break
    case 2:
      filteredProducts.value = desserts.value
      break
    case 3:
      filteredProducts.value = foods.value

      break
    default:
      filteredProducts.value = []
      break
  }
}
updateFilteredProducts()
const searchProducts = async () => {
  if (!searchQuery.value) {
    await updateFilteredProducts()
    return
  }
  switch (tab.value) {
    case 1:
      filteredProducts.value = drinks.value.filter((product) =>
        product.name.toLowerCase().includes(searchQuery.value.toLowerCase())
      )
      break
    case 2:
      filteredProducts.value = desserts.value.filter((product) =>
        product.name.toLowerCase().includes(searchQuery.value.toLowerCase())
      )
      break
    case 3:
      filteredProducts.value = foods.value.filter((product) =>
        product.name.toLowerCase().includes(searchQuery.value.toLowerCase())
      )
      break
    default:
      filteredProducts.value = []
      break
  }
}
watch(tab, async (newValue) => {
  if (newValue === 1) {
    loadingStore.doLoad()
    await searchProducts()
    loadingStore.finish()
  } else if (newValue === 2) {
    loadingStore.doLoad()
    await searchProducts()
    loadingStore.finish()
  } else if (newValue === 3) {
    loadingStore.doLoad()
    await searchProducts()
    loadingStore.finish()
  }
})
const paymentMethod = ref('1')
const showReceiptAndCashDialog = () => {
  if (paymentMethod.value === '1') {
    cashdialog.value = true
    paymentStore.pay = 'Cash'
  } else if (paymentMethod.value === '2') {
    qrcodedialog.value = true
    paymentStore.pay = 'QR CODE'
    paymentStore.cash = receiptStore.receipt.total
  } else {
    promptpaydialog.value = true
    paymentStore.pay = 'PromptPay'
    paymentStore.cash = receiptStore.receipt.total
  }
}
onMounted(async () => {
  await productStore.getProducts()
  updateFilteredProducts()
})
</script>
<template>
  <v-container>
    <v-row justify="center">
      <v-col cols="8" md="6" style="max-width: 800px">
        <v-row>
          <v-col cols="12">
            <v-sheet
              min-width="300"
              max-width="100%"
              height="70"
              style="background-color: #8b7565"
              elevation="6"
            >
              <v-card-text>
                <v-text-field
                  style="margin-top: -8px"
                  v-model="searchQuery"
                  dense
                  variant="solo"
                  label="Search for products"
                  append-inner-icon="mdi-magnify"
                  single-line
                  hide-details
                  @click:append-inner="searchProducts"
                  @keyup.enter="searchProducts"
                ></v-text-field>
              </v-card-text>
            </v-sheet>
          </v-col>
          <v-col cols="12">
            <v-sheet
              min-width="300"
              max-width="100%"
              height="843"
              style="background-color: #efe7e1"
              elevation="6"
              ><v-tabs v-model="tab" centered stacked>
                <v-tab :value="1">
                  <v-icon>mdi-coffee</v-icon>
                  Drinks
                </v-tab>

                <v-tab :value="2">
                  <v-icon>mdi-cake</v-icon>
                  Desserts
                </v-tab>

                <v-tab :value="3">
                  <v-icon>mdi-food</v-icon>
                  Foods
                </v-tab>
              </v-tabs>
              <v-window v-model="tab">
                <v-window-item :value="1">
                  <ProductList
                    :products="filteredProducts"
                    @selectedProduct="selected"
                  ></ProductList>
                </v-window-item>

                <v-window-item :value="2">
                  <ProductList
                    :products="filteredProducts"
                    @selectedProduct="selected"
                  ></ProductList>
                </v-window-item>

                <v-window-item :value="3">
                  <ProductList
                    :products="filteredProducts"
                    @selectedProduct="selected"
                  ></ProductList> </v-window-item></v-window
            ></v-sheet>
          </v-col>
        </v-row>
      </v-col>
      <v-col cols="4" md="6" style="max-width: 600px">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <v-sheet
                min-width="150"
                max-width="600"
                height="70"
                style="background-color: #8b7565"
                elevation="6"
                ><MemberCard></MemberCard
              ></v-sheet>
            </v-col>
            <v-col cols="12">
              <div ref="divReceiptItems" style="height: 300; overflow: auto">
                <v-sheet
                  min-width="150"
                  max-width="600"
                  height="480"
                  style="background-color: #efe7e1"
                  elevation="6"
                >
                  <ReceiptDetailTable></ReceiptDetailTable>
                </v-sheet>
              </div>
            </v-col>
            <v-col cols="12">
              <v-sheet
                min-width="150"
                max-width="600"
                height="110"
                style="background-color: #efe7e1"
                elevation="6"
                ><ReceiptCard></ReceiptCard
              ></v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet
                min-width="150"
                max-width="600"
                height="100"
                style="background-color: #efe7e1"
                elevation="6"
              >
                <v-container
                  >Payment types
                  <v-row>
                    <v-radio-group v-model="paymentMethod" inline>
                      <v-col><v-radio label="Cash" value="1"></v-radio></v-col>
                      <v-col><v-radio label="QR Code" value="2"></v-radio></v-col>
                      <v-col><v-radio label="PromptPay" value="3"></v-radio></v-col>
                    </v-radio-group>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet
                min-width="150"
                max-width="600"
                height="80"
                style="background-color: #efe7e1"
                elevation="6"
                ><v-container>
                  <v-row style="text-align: center">
                    <v-col cols="12" sm="6">
                      <v-btn size="large" color="red" @click="clearReceipt">Cancel</v-btn> </v-col
                    ><v-col cols="12" sm="6">
                      <v-btn size="large" color="primary" @click="showReceiptAndCashDialog"
                        >Make payment</v-btn
                      >
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <Payment></Payment>
  <QrcodeDialog></QrcodeDialog>
  <Promptpay></Promptpay>
</template>
<style scoped></style>
@/stores/http
